//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "ITSDbF.h"
#include "AppGlobalF.h"
#include "WindowMsgF.h"
#pragma hdrstop

#include "AVIH0101F.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxCheckBox"
#pragma link "cxClasses"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxStyles"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma resource "*.dfm"

TAVIH0101 *AVIH0101 = NULL;

//---------------------------------------------------------------------------
__fastcall TAVIH0101::TAVIH0101(TComponent* Owner, HWND hHandle, String sFrom, String sTo, String sIdList)
    : TForm(Owner)
{           
    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    FParent     = hHandle;
    FStDateTime = sFrom;
    FEdDateTime = sTo;
    FIdList     = sIdList;

    Column10->Visible = true;

    Caption = "AVI-제어기 상태 이력";
}
//---------------------------------------------------------------------------

__fastcall TAVIH0101::~TAVIH0101(void)
{
}
//--------------------------------------------------------------------------

/*
 * form 초기화
 *
 *  arguments
 *
 *  return
 *      void
 */
void __fastcall TAVIH0101::FormInit()
{
    ADOQry->Connection = ITSDb_GetConnection();
    m_pGDC = TvList->DataController;

    TvList->OptionsView->NoDataToDisplayInfoText = FrmLang->lblNoInfo->Caption;//"<AVI-제어기 상태 이력 정보>";
	//TvList->ViewInfo->GroupByBoxViewInfo->Text = "그룹핑할 필드의 헤더를 이곳으로 드래그 하세요";
    LblSearch->Caption = "검색조건: " + FStDateTime.SubString(1, 12) + " ~ " + FEdDateTime.SubString(1, 12);
}
//---------------------------------------------------------------------------

/*
 * form을 보여줄때 호출되는 event 메서드이다.
 *  arguments
 *      Sender : event handler 객체
 *  return
 *      void
 */
void __fastcall TAVIH0101::FormShow(TObject *Sender)
{
    FormInit();
    Refresh();
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

/*
 * 닫기버튼 이나 x버튼 클릭시 공통으로 처리하는 로직이들어간다..
 * Form과 DataModule class를 delete시킨다.
 *  arguments
 *
 *  return
 *      void
 */
void __fastcall TAVIH0101::CommClose()
{
    CMM_SaveForm(g_sFormsDir, this);
    //AVIH0101 = NULL;
}
//---------------------------------------------------------------------------

/*
 * 최초 1회 수행되는 타이머 이벤트
 *  arguments
 *      Sender : event handler 객체
 *  return
 *      void
 */
void __fastcall TAVIH0101::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false; 
    Application->ProcessMessages();
    SelHistory();
}
//---------------------------------------------------------------------------

void __fastcall TAVIH0101::ChkExpandClick(TObject *Sender)
{
    CMM_ExpandCollapseChk(TvList, ChkExpand->Checked);
}
//---------------------------------------------------------------------------

/*
 * Refresh Data Event Function
 *  arguments
 *
 *  return
 *      void
 */
void __fastcall TAVIH0101::SelHistory()
{
    TSqlCursor sqlCrs;

    String sQry;
    TADOQuery *pADO = ADOQry;

    sQry = "SELECT A.AVI_CTLR_MNGM_NMBR, B.AVI_ID, B.AVI_LCTN_NM, A.CRTN_DT,                                                               \r\n"
           "       (SELECT CMMN_CD_KOR_NM FROM TB_CMMN_CD WHERE CMMN_CD = A.CMNC_STTS_CD      AND CMMN_CLSF_CD = 'CMS') CMNC_STTS_CD,      \r\n"
		   "       (SELECT CMMN_CD_KOR_NM FROM TB_CMMN_CD WHERE CMMN_CD = A.CBOX_DOOR_STTS_CD AND CMMN_CLSF_CD = 'CDS') CBOX_DOOR_STTS_CD, \r\n"
		   "       (SELECT CMMN_CD_KOR_NM FROM TB_CMMN_CD WHERE CMMN_CD = A.FAN_STTS_CD       AND CMMN_CLSF_CD = 'PAS') FAN_STTS_CD,       \r\n"
		   "       (SELECT CMMN_CD_KOR_NM FROM TB_CMMN_CD WHERE CMMN_CD = A.HETR_STTS_CD      AND CMMN_CLSF_CD = 'HTS') HETR_STTS_CD,      \r\n"
		   "       (SELECT CMMN_CD_KOR_NM FROM TB_CMMN_CD WHERE CMMN_CD = A.VOLT_STTS_CD      AND CMMN_CLSF_CD = 'VTS') VOLT_STTS_CD,      \r\n"
		   "       (SELECT CMMN_CD_KOR_NM FROM TB_CMMN_CD WHERE CMMN_CD = A.LAMP_STTS_CD      AND CMMN_CLSF_CD = 'LAS') LAMP_STTS_CD,      \r\n"
           "       CBOX_TMPR, CMRA_MTNS_STTS_CD                                                                                            \r\n"
           "  FROM TB_AVI_CTLR_STTS_HS A, TB_AVI_CTLR B                                                                                    \r\n"
           " WHERE A.CRTN_DT BETWEEN :p01 AND :p02                                                                                         \r\n"
           "   AND A.AVI_CTLR_MNGM_NMBR = B.AVI_CTLR_MNGM_NMBR                                                                             \r\n"
           "   AND B.AVI_CTLR_MNGM_NMBR IN(" + FIdList + ")                                                                                \r\n"
           " ORDER BY A.AVI_CTLR_MNGM_NMBR ASC, A.CRTN_DT DESC                                                                             \r\n";

    try
    {
        ITSDb_SQLText(pADO, sQry);
        ITSDb_SQLBind(pADO, "p01", FStDateTime);
        ITSDb_SQLBind(pADO, "p02", FEdDateTime);
        ITSDb_SQLOpen(pADO);

        DspHistory();
    }
    catch(EDatabaseError &E)
    {
        ::PostMessage(Application->MainForm->Handle, (UINT)(WM_USER+0xF4), (WPARAM)0xB2, (LPARAM)0xB2);
        DBERRORMSG(Caption, String(E.ClassName()), E.Message, sQry);
        throw Exception(String(E.ClassName()) + E.Message);
    }
    catch(Exception &exception)
    {
        ::PostMessage(Application->MainForm->Handle, (UINT)(WM_USER+0xF4), (WPARAM)0xB2, (LPARAM)0xB2);
        DBERRORMSG(Caption, String(exception.ClassName()), exception.Message, sQry);
        throw Exception(String(exception.ClassName()) + exception.Message);
    }
}
//---------------------------------------------------------------------------

void __fastcall TAVIH0101::DspHistory()
{
    TADOQuery *pADO = ADOQry;

    try
    {
    	TcxGridChartSeries *pChart = NULL;

        CMM_ClearGridTableView(TvList);

        int nRow = 0;
        int nDataCnt = 0;
        try {
            TvList->BeginUpdate();

            nDataCnt = pADO->RecordCount;
            m_pGDC->RecordCount = nDataCnt;

            for( ; !pADO->Eof; pADO->Next(), nRow++)
            {
                m_pGDC->Values[nRow][Column00->Index] = pADO->FieldByName("AVI_CTLR_MNGM_NMBR")->AsString;
                m_pGDC->Values[nRow][Column11->Index] = pADO->FieldByName("AVI_ID")->AsString;
                m_pGDC->Values[nRow][Column01->Index] = ITSUtil_StrToDateTime(pADO->FieldByName("CRTN_DT")->AsString).FormatString(STR_DATETIME);   //TODO
                m_pGDC->Values[nRow][Column06->Index] = pADO->FieldByName("AVI_LCTN_NM")->AsString;

                String sCmnc = pADO->FieldByName("CMNC_STTS_CD")->AsString;
                String sDoor = pADO->FieldByName("CBOX_DOOR_STTS_CD")->AsString;
                String sFan  = pADO->FieldByName("FAN_STTS_CD")->AsString;
                String sHetr = pADO->FieldByName("HETR_STTS_CD")->AsString;
                String sTmpr = pADO->FieldByName("CBOX_TMPR")->AsString;
                String sCmra = pADO->FieldByName("CMRA_MTNS_STTS_CD")->AsString;
                String sVolt = pADO->FieldByName("VOLT_STTS_CD")->AsString;
                String sLamp = pADO->FieldByName("LAMP_STTS_CD")->AsString;

                m_pGDC->Values[nRow][Column02->Index] = sCmnc;
                m_pGDC->Values[nRow][Column03->Index] = sDoor;
                m_pGDC->Values[nRow][Column04->Index] = sFan;
                m_pGDC->Values[nRow][Column05->Index] = sHetr;
                m_pGDC->Values[nRow][Column07->Index] = sCmra;
                m_pGDC->Values[nRow][Column08->Index] = sVolt;
                m_pGDC->Values[nRow][Column09->Index] = sLamp;
                m_pGDC->Values[nRow][Column10->Index] = sTmpr;
            }
        }
        __finally
        {
            if (pADO)
            {
                pADO->Close();
            }

            TvList->EndUpdate();
            //CxList->SetFocus();
            LblRecords->Caption = FormatFloat("##,##0", m_pGDC->RecordCount) + " 건";

            String sEnd = "데이터 " + LblRecords->Caption + " 이 조회 되었습니다.";
            Application->MessageBox(sEnd.c_str(), L"데이터 조회 완료", MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
        }
    }
    catch(EDatabaseError &E)
    {
        throw Exception(String(E.ClassName()) + E.Message);
    }
    catch(...)
    {
        throw Exception(FrmLang->lblDbErr->Caption);//"알수없는 오류가 발생하였습니다.");
    }
}
//---------------------------------------------------------------------------

void __fastcall TAVIH0101::OnMessage(TMessage &Msg)
{
    switch (Msg.Msg)
    {
    case WM_PARAM_DATABASE:
        if (WP_DB_SELECT_OK == Msg.WParam)
        {
            //ShowMessage("Select Ok");
        }
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TAVIH0101::BtnExlSaveClick(TObject *Sender)
{
    TcxGrid          *pGrid = CxList;
    TcxGridTableView *pView = TvList;
    String            sTitle = "AVI-제어기 상태이력";

    CMM_ExportToExcelFile(sTitle, pGrid, pView, this);
}
//---------------------------------------------------------------------------

void __fastcall TAVIH0101::FormClose(TObject *Sender, TCloseAction &Action)
{
    POST_MSG(FParent, WM_SUBFORM_CLOSE, 0, 0);
    CommClose();
    //AVIH0101 = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TAVIH0101::Column02CustomDrawCell(TcxCustomGridTableView *Sender, TcxCanvas *ACanvas, TcxGridTableDataCellViewInfo *AViewInfo,
          bool &ADone)
{
	if( AViewInfo )
	{
		if(AViewInfo->Text == "정상")
		{
			ACanvas->Canvas->Font->Color = clTeal;
		}
		else if(AViewInfo->Text == "장애")
		{
			ACanvas->Canvas->Font->Color = clFuchsia;
		}
		else
		{
			ACanvas->Canvas->Font->Color = clGray;
		}
	}
}
//---------------------------------------------------------------------------

